export function notification(title, content, details) {
    return new Promise((resolve) => {
        let ret = {
            update(details) {
                GM_updateNotification(ret.id, details);
            },
            close() {
                GM_closeNotification(ret.id);
            },
            done(callback) {
                ret.ondone = callback;
            },
            click(callback) {
                ret.onclick = callback;
            },
        };
        let d = Object.assign({}, details);
        d.title = title;
        d.text = content;
        d.oncreate = (id) => {
            ret.id = id;
            resolve(ret);
        };
        d.ondone = (clicked, id) => {
            ret.ondone && ret.ondone(clicked, id);
        };
        d.onclick = (id, index) => {
            ret.onclick && ret.onclick(id, index);
        };
        GM_notification(d);
    });
}
//# sourceMappingURL=utils.js.map