import { Message as ArcoMessage } from "@arco-design/web-react";
import UIPage from "../page";
// @ts-ignore
import arcoCss from "../arco.css";
const messageElName = "cat-ui-message";
let arcoMessage;
class Message extends HTMLElement {
    options;
    constructor() {
        super();
        // @ts-ignore
        this.options = Message.options || {};
        this.options.render = () => {
            const [message, contextHolder] = ArcoMessage.useMessage();
            arcoMessage = message;
            // @ts-ignore
            this.options.onReady && this.options.onReady();
            return contextHolder;
        };
        this.options.style = arcoCss;
        UIPage.render(this);
    }
    static init() {
        if (document.body.querySelector(messageElName)) {
            return Promise.resolve();
        }
        return new Promise((resolve) => {
            // @ts-ignore
            Message.options = {
                onReady() {
                    resolve();
                },
            };
            let div = document.createElement("div");
            div.innerHTML = "<" + messageElName + " />";
            document.body.append(div);
        });
    }
    static async info(text) {
        await this.init();
        arcoMessage.info && arcoMessage.info(text);
    }
    static async error(text) {
        await this.init();
        arcoMessage.error && arcoMessage.error(text);
    }
    static async normal(text) {
        await this.init();
        arcoMessage.normal && arcoMessage.normal(text);
    }
    static async warning(text) {
        await this.init();
        arcoMessage.warning && arcoMessage.warning(text);
    }
    static async success(text) {
        await this.init();
        arcoMessage.success && arcoMessage.success(text);
    }
}
customElements.define(messageElName, Message);
export default Message;
//# sourceMappingURL=message.js.map