import { MutableRefObject } from "react";
import { UIPageOptions } from "./page";
export declare type UIPanelOptions = UIPageOptions & {
    min?: boolean;
    point?: {
        x: number;
        y: number;
    };
    header?: {
        title?: string;
    };
    footer?: {
        version?: string;
    };
    onReady?: (panel: UIPanel) => void;
};
declare class UIPanel extends HTMLElement {
    options: UIPanelOptions;
    constructor();
    draggableStopCallback?: (event: {
        x: number;
        y: number;
    }) => void;
    onDraggableStop(callback: (event: {
        x: number;
        y: number;
    }) => void): void;
    protected defaultOptions(): void;
    static DefaultHeader(props: {
        title: string;
        min?: boolean;
        panel: MutableRefObject<HTMLElement | undefined>;
        onMin?: () => void;
    }): import("react/jsx-runtime").JSX.Element;
    static DefaultFooter(props: {
        version?: string;
    }): import("react/jsx-runtime").JSX.Element;
}
export default UIPanel;
