import { MutableRefObject } from "react";
import { UIPageOptions } from "./page";
export declare type UIPlanOptions = UIPageOptions & {
    appendStyle?: string;
    min?: boolean;
    point?: {
        x: number;
        y: number;
    };
    header?: {
        title?: string;
    };
    footer?: {
        version?: string;
    };
    onReady?: (plan: UIPlan) => void;
};
declare class UIPlan extends HTMLElement {
    options: UIPlanOptions;
    constructor();
    draggableStopCallback?: (event: {
        x: number;
        y: number;
    }) => void;
    onDraggableStop(callback: (event: {
        x: number;
        y: number;
    }) => void): void;
    protected defaultOptions(): void;
    static DefaultHeader(props: {
        title: string;
        min?: boolean;
        plan: MutableRefObject<HTMLElement | undefined>;
        onMin?: () => void;
    }): import("react/jsx-runtime").JSX.Element;
    static DefaultFooter(props: {
        version?: string;
    }): import("react/jsx-runtime").JSX.Element;
}
export default UIPlan;
