import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useRef, useState } from "react";
import UIPage from "./page";
import { Button, Layout, Typography } from "@arco-design/web-react";
import { IconMinus } from "@arco-design/web-react/icon";
import Draggable from "react-draggable";
// @ts-ignore
import arcoCss from "./arco.css";
// 创建UI面板
class UIPlan extends HTMLElement {
    options;
    constructor() {
        super();
        // @ts-ignore
        this.options = UIPlan.options;
        this.defaultOptions();
        const oldRender = this.options.render;
        const Child = () => {
            const ret = oldRender();
            if (ret instanceof Array) {
                return ret.map((val) => {
                    return val;
                });
            }
            return ret;
        };
        this.options.render = () => {
            const ref = useRef();
            const [min, setMin] = useState(false);
            return (_jsx(Draggable, Object.assign({ handle: ".draggable", onStop: (e, d) => {
                    this.draggableStopCallback &&
                        this.draggableStopCallback({
                            x: d.x,
                            y: d.y,
                        });
                } }, { children: _jsxs(Layout, Object.assign({ style: {
                        position: "absolute",
                        border: "1px solid var(--color-border-2)",
                        background: "var(--color-bg-1)",
                        top: "0px",
                        left: "0px",
                        borderRadius: "6px",
                        zIndex: "1000",
                    }, ref: ref }, { children: [_jsx(UIPlan.DefaultHeader, { title: this.options.header?.title || "UIPlan", min: min, onMin: () => setMin(!min), plan: ref }, void 0),
                        !min && (_jsx(Layout.Content, Object.assign({ style: {
                                padding: "4px 6px",
                            } }, { children: _jsx(Child, {}, void 0) }), void 0)),
                        !min && (_jsx(UIPlan.DefaultFooter, { version: this.options.footer?.version }, void 0))] }), void 0) }), void 0));
        };
        UIPage.render(this);
        this.options.onReady && this.options.onReady(this);
    }
    draggableStopCallback;
    onDraggableStop(callback) {
        this.draggableStopCallback = callback;
    }
    defaultOptions() {
        if (!this.options.style) {
            this.options.style = arcoCss;
            this.options.style += `
        .flex{
          display: flex;
          flex: 1;
        }
        
        .justify-between{
          justify-content: space-between;
        }

        .min-btn:hover{
          color: var(--color-primary-5);
          background: var(--color-bg-2);
        }
      `;
        }
        if (!this.options.appendStyle) {
            this.options.style += this.options.appendStyle;
        }
        if (!this.options.header) {
            this.options.header = {};
        }
        if (!this.options.footer) {
            this.options.footer = {};
        }
    }
    static DefaultHeader(props) {
        return (_jsxs(Layout.Header, Object.assign({ className: "flex", style: {
                alignItems: "center",
                padding: "4px 6px",
            } }, { children: [_jsx("div", Object.assign({ className: "draggable", style: {
                        flex: 1,
                        cursor: "move",
                    } }, { children: _jsx(Typography.Text, Object.assign({ style: { fontSize: "16px" } }, { children: props.title }), void 0) }), void 0),
                _jsx(Button, { type: "text", className: "min-btn", icon: _jsx(IconMinus, {}, void 0), iconOnly: true, size: "small", onClick: () => {
                        props.onMin && props.onMin();
                    } }, void 0)] }), void 0));
    }
    static DefaultFooter(props) {
        return (_jsx(Layout.Footer, Object.assign({ className: "flex", style: {
                alignItems: "center",
                padding: "4px 6px",
            } }, { children: _jsx("div", Object.assign({ className: "flex" }, { children: props.version && props.version }), void 0) }), void 0));
    }
}
export default UIPlan;
//# sourceMappingURL=plan.js.map