import { jsx as _jsx } from "react/jsx-runtime";
import { useState } from "react";
import UIPage from "./page";
import { Button, Checkbox, Input, Select, Typography, } from "@arco-design/web-react";
import UIPlan from "./plan";
import Message from "./component/message";
const pageElName = "cat-ui-page";
window.customElements.define(pageElName, UIPage);
const planElName = "cat-ui-plan";
window.customElements.define(planElName, UIPlan);
const CAT_UI = {
    create(options) {
        // @ts-ignore
        UIPage.options = options;
        let div = document.createElement("div");
        div.innerHTML = "<" + pageElName + " />";
        document.body.append(div);
    },
    createPlan(options) {
        // @ts-ignore
        UIPlan.options = options;
        let div = document.createElement("div");
        div.innerHTML = "<" + planElName + " />";
        document.body.append(div);
    },
    UIPlan,
    useState(data) {
        return useState(data);
    },
    Text(text, props) {
        return _jsx(Typography, Object.assign({}, props, { children: text }), void 0);
    },
    Input(props) {
        return _jsx(Input, Object.assign({}, props), void 0);
    },
    Button(text, props) {
        if (typeof text === "string") {
            return _jsx(Button, Object.assign({}, props, { children: text }), void 0);
        }
        return _jsx(Button, Object.assign({}, props), void 0);
    },
    Checkbox(text, props) {
        if (typeof text === "string") {
            return _jsx(Checkbox, Object.assign({}, props, { children: text }), void 0);
        }
        return _jsx(Checkbox, Object.assign({}, props), void 0);
    },
    Select(options, props) {
        if (options instanceof Array) {
            return _jsx(Select, Object.assign({}, props, { children: options }), void 0);
        }
        return _jsx(Select, Object.assign({}, props), void 0);
    },
    Message: Message,
};
CAT_UI.Select.prototype.Option = function (props) {
    return _jsx(Select.Option, Object.assign({}, props), void 0);
};
export default CAT_UI;
//# sourceMappingURL=ui.js.map